import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkUserBind, ThinkUserBindParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkUserBind(params: ThinkUserBindParam) {
  const res = await request.get<ApiResult<PageResult<ThinkUserBind>>>(
    THINK_API_URL + '/think/think-user-bind/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkUserBind(params?: ThinkUserBindParam) {
  const res = await request.get<ApiResult<ThinkUserBind[]>>(
    THINK_API_URL + '/think/think-user-bind',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkUserBind(data: ThinkUserBind) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-user-bind',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkUserBind(data: ThinkUserBind) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-user-bind',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkUserBind(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-user-bind/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkUserBind(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-user-bind/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkUserBind(id: number) {
  const res = await request.get<ApiResult<ThinkUserBind>>(
    THINK_API_URL + '/think/think-user-bind/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
